<div>
  <table class="table table-striped table-bordered table-condensed mat-elevation-z8 mat-table {{standalone ? 'full-table': ''}}" >
      <thead>
        <tr class="mat-header-row">
          <th class="mat-header-cell"
              style="cursor:pointer"
              (click)="onPlayerClick()"
              (mouseover)="columnHovered = -1"
              (mouseout)="columnHovered = null">
            Player
            <ng-container *ngIf="sortedColumn === -1 || columnHovered === -1;else hide_sort">
                <span *ngIf="sortedDesc"> ▼ </span>
                <span *ngIf="!sortedDesc"> ▲ </span>
              </ng-container>
              <ng-template #hide_sort>
                <span style="opacity: 0"> ▼ </span>
              </ng-template>
          </th>
          <ng-container *ngFor="let level of tableLevelHeader; let i = index">
            <th class="mat-header-cell">
              <span style="cursor:pointer" (click)="onLevelClick(i)" (mouseover)="columnHovered = i" (mouseout)="columnHovered = null">
                Level {{ i + 1}}
              </span> <br>
              <span style="font-size: 10px; cursor:pointer" (click)="onLevelClick(i)"
                    (mouseover)="columnHovered = i" (mouseout)="columnHovered = null">
                <span>
                  {{standalone || (!filters.hintFilter.checked && !filters.wrongAnswerFilter.checked) ? 'Score' : 'S'}}
                </span>
                <ng-container *ngIf="sortedColumn === i || columnHovered === i;else hide_sort">
                    <span *ngIf="sortedDesc">▼</span>
                    <span *ngIf="!sortedDesc">▲</span>
                </ng-container>
                <ng-template #hide_sort>
                    <span style="opacity: 0">▼</span>
                </ng-template>
              </span>
              <ng-container *ngIf="standalone || filters.hintFilter.checked || filters.wrongAnswerFilter.checked">
                <span
                  style="font-size: 10px; cursor:pointer"
                  *ngIf="standalone || filters.wrongAnswerFilter.checked"
                  (click)="onWrongClick(i)"
                  (mouseover)="columnHovered = 'w'+i"
                  (mouseout)="columnHovered = null" >
                  / <span style="opacity: 0"> | </span>
                  <span>{{standalone ? 'Wrong answers' : 'WA'}}</span>
                    <ng-container *ngIf="sortedColumn === 'w'+i  || columnHovered === 'w'+i; else hide_sort">
                    <span *ngIf="sortedDesc">▼</span>
                    <span *ngIf="!sortedDesc">▲</span>
                </ng-container>
                <ng-template #hide_sort>
                    <span style="opacity: 0">▼</span>
                </ng-template>
                </span>
                <span style="font-size: 10px; cursor:pointer" *ngIf="standalone || filters.hintFilter.checked" (click)="onHintsClick(i)"
                (mouseover)="columnHovered = 'h'+i" (mouseout)="columnHovered = null"
                > / <span style="opacity: 0"> | </span>
                  <span>{{standalone ? 'Hints taken' : 'H'}}</span>
                    <ng-container *ngIf="sortedColumn === 'h'+i  || columnHovered === 'h'+i; else hide_sort">
                    <span *ngIf="sortedDesc">▼</span>
                    <span *ngIf="!sortedDesc">▲</span>
                </ng-container>
                <ng-template #hide_sort>
                    <span style="opacity: 0">▼</span>
                </ng-template>
                </span>
              </ng-container>
            </th>
          </ng-container>
          <th class="mat-header-cell"
              style="cursor:pointer"
              (click)="onFinalClick()"
              (mouseover)="columnHovered = -2"
              (mouseout)="columnHovered = null">
            Final<br>
            <span style="font-size: 10px;"> Score
                <ng-container *ngIf="sortedColumn === -2  || columnHovered === -2; else hide_sort">
                    <span *ngIf="sortedDesc">▼</span>
                    <span *ngIf="!sortedDesc">▲</span>
                </ng-container>
                <ng-template #hide_sort>
                    <span style="opacity: 0">▼</span>
                </ng-template>
            </span>
          </th>
        </tr>
      </thead>
      <tbody role="rowgroup" class="mdc-data-table__content">
        <ng-container *ngFor="let player of playersOrdered">
          <tr class="mat-mdc-row" *ngIf="player"
            [ngStyle]="{'cursor': standalone ? 'default' : 'pointer' }"
            (click)="!standalone ? onRowClick(player) : null"
            (mouseover)="!standalone ?  onRowMouseover(player): null"
            (mouseout)="!standalone ? onRowMouseout(player): null"
            [ngClass]="{'checked' : standalone ? false : player.checked}">
            <td class="mat-cell">
              <div *ngIf="player.checked" class="row-stripe" [ngStyle]="{'background': player.avatarColor }"></div>
              <span [ngStyle]="{
              'font-weight': player.trainingRunId === traineesTrainingRun ? 'bold' : 'normal',
              'padding-right': '10px'
              }">{{
                player.name
              }}</span>
              <ng-container *ngIf="!standalone">
                <input style="display:none;" type="checkbox" name="player" [id]="player.id" [(ngModel)]="player.checked">
              </ng-container>
            </td>
            <ng-container *ngFor="let level of player.levels">
              <td class="mat-mdc-cell">
                <ng-container *ngIf="level">
                    {{ level.participantLevelScore }}
                    <span *ngIf="standalone || filters.wrongAnswerFilter.checked">
                      / {{ level.wrongAnswers }}
                    </span>
                    <span *ngIf="standalone || filters.hintFilter.checked">
                        / {{ level.hintsTaken }}
                    </span>
                </ng-container>
                <span *ngIf="!level">
                  -
                </span>
              </td>
            </ng-container>
            <td class="mat-cell">{{ player.totalScore }}</td>
          </tr>
        </ng-container>
      </tbody>
    </table>
</div>

<!-- material table outline -->
<table mat-table [dataSource]="" class="mat-elevation-z8" style="display: none">
<ng-container [matColumnDef]="column" *ngFor="let column of []">
  <th mat-header-cell *matHeaderCellDef mat-sort-header> {{column}} </th>
  <td mat-cell *matCellDef="let element"> {{element[column]}} </td>
</ng-container>

<tr mat-header-row *matHeaderRowDef="[]"></tr>
<tr mat-row *matRowDef="let row; columns: [];"></tr>
</table>
